<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import { usePosStore } from '../stores/pos'
import { useReceiptStore } from '@/Receipt/stores/receipt'
import type { Product } from '@/Product/types/Product'
import ReceiptItemList from '../components/ReceiptItemList.vue'
import type { ReceiptItem } from '@/Pos/types/ReceiptItem'

const posStore = usePosStore()
const receiptStore = useReceiptStore()
const productName = ref('')
const snackbar = ref(false)
const divReceiptItems = ref<HTMLElement | null>(null)
function onClick() {}
const tab = ref(null)
// onMounted(async () => {
//   await posStore.getProducts()
// })
const product = ref<Product>()
// const selected = (p: Product) => {
//   console.log('ProductView' + p)
//   receiptStore.addReceiptItem(p)
//   nextTick(() => {
//     if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
//   })
// }

function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    productId: p.id
  }
  receiptStore.addReceiptItem(newReceiptItem)
  snackbar.value = true
}

onMounted(async () => {
  await posStore.getProducts()
})
</script>

<template>
  <v-container class="fill-height" fluid>
    <v-row>
      <!-- Left Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="100%" elevation="0" rounded style="background-color: rgba(0, 0, 0, 0.8)">
          <v-img
            height="100"
            src="https://i.pinimg.com/564x/22/49/84/224984972b3a833cb764dd7bdc512054.jpg"
            style="opacity: 1"
            cover
          >
            <v-container>
              <v-row>
                <v-col>
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: rgb(255, 255, 255);
                      font-size: 35px;
                    "
                  >
                    Point of Sale
                  </h1>
                </v-col>
                <v-col></v-col>
              </v-row>
            </v-container>
          </v-img>

          <v-tabs color="orange" align-tabs="start" class="ma-5" style="color: aliceblue">
            <v-tab :value="1"><v-icon icon="mdi-coffee"></v-icon>Drink</v-tab>
            <v-tab :value="2"><v-icon icon="mdi-cake-variant"></v-icon>Bakery</v-tab>
            <v-tab :value="3"><v-icon icon="mdi-silverware-fork-knife"></v-icon>Food</v-tab>
            <!-- <v-text-field v-model="productName" density="compact" variant="solo" label="Product Search"
                            class="pa-2" append-inner-icon="mdi-magnify" single-line hide-details
                            @click:append-inner="onClick" @keyup.enter="onClick"></v-text-field> -->
          </v-tabs>

          <!-- search bar -->
          <v-container>
            <v-row>
              <v-spacer />
              <v-col cols="6">
                <v-text-field
                  v-model="productName"
                  density="compact"
                  variant="solo"
                  label="Product Search"
                  append-inner-icon="mdi-magnify"
                  single-line
                  hide-details
                  @click:append-inner="onClick"
                  @keyup.enter="onClick"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>

          <!-- <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="posStore.products1" @selected-product="selected">
              </ProductList>
              {{ productsStore.currentProduct }}
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="posStore.products2" @selected-product="selected">
              </ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="posStore.products3" @selected-product="selected">
              </ProductList>
            </v-window-item>
          </v-window> -->

          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList
                :products="posStore.products1"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList
                :products="posStore.products2"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList
                :products="posStore.products3"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <!-- Right Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="auto" elevation="0" rounded style="background-color: rgba(0, 0, 0, 0.8)">
          <v-row no-gutters>
            <!-- Nested Containers -->

            <!-- Receipt Detail Table -->
            <v-col cols="12">
              <v-sheet elevation="0" rounded style="background-color: rgba(205, 129, 61, 0.66)">
                <v-img
                  height="80"
                  src="https://i.pinimg.com/564x/78/e3/7d/78e37d57fd461ee7fd594e1efe2715ce.jpg"
                  style="opacity: 1"
                  cover
                >
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: black;
                      padding-left: 35px;
                      margin: 5px;
                      font-size: 38px;
                    "
                  >
                    Order List
                  </h1>
                </v-img>
                <ReceiptItemList :tableHeight="420"></ReceiptItemList>
              </v-sheet>
            </v-col>

            <!-- Duplicate ReceiptDetailTable -->
            <!-- <v-sheet width="auto" height="250" elevation="6">
                                <ReceiptDetailTable></ReceiptDetailTable>
                            </v-sheet> -->

            <!-- MemberCard and PointCard -->

            <!-- <v-col cols="12">
              <h3 style="cursor: pointer;" class="pl-5" @click="showMemberBox = !showMemberBox">Member Action<v-icon
                  :icon="showMemberBox ? 'mdi-chevron-up' : 'mdi-chevron-down'"></v-icon></h3>
              <v-expand-transition>
                <div v-show="showMemberBox">
                  <v-row no-gutters>
                    <v-col cols="6">
                      <v-sheet width="auto" height="150" elevation="0"
                        style="background-color: #fef1dea4; color: black">
                        <MemberCard />
                      </v-sheet>
                    </v-col>
                    <v-col cols="6">
                      <v-sheet width="auto" height="150" elevation="0"
                        style="background-color:  #fef1dea4; color: black">
                        <PointCard></PointCard>
                      </v-sheet>
                    </v-col>
                  </v-row>

                </div>
              </v-expand-transition>

            </v-col> -->

            <!-- <v-divider vertical color="black"></v-divider> -->
            <!-- <v-col cols="6">
                            
                        </v-col> -->

            <!-- ReceiptCard and PaymentCard -->
            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"
              >
                <!-- <ReceiptCard /> -->
              </v-sheet>
            </v-col>
            <v-divider vertical color="black"></v-divider>
            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: rgba(205, 129, 61, 0.66); color: white"
              >
                <!-- <PaymentCard /> -->
              </v-sheet>
            </v-col>
          </v-row>

          <!-- Buttons and Actions -->
          <!-- <v-container>
            <v-row>
              <v-col cols="6">
                <v-btn block rounded="l" color="#a16942" size="large" @click="showMemberDialog()">
                  <v-icon start icon="mdi-wallet-membership"></v-icon>Register Member
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn block rounded="l" color="red-lighten-1" size="large" @click="() => {
            receiptStore.clear()

          }">
                  <v-icon start icon="mdi-close"></v-icon>Cancel
                </v-btn>
              </v-col>
              <v-col cols="6">
                <v-btn block rounded="l" color="#693a18" size="large" @click="showPromotionDialog()">
                  <v-icon start icon="mdi-star"></v-icon>Promotion
                </v-btn>
              </v-col>

              <v-col cols="6">
                <v-btn block rounded="l" color="green-darken-2" size="large" @click="receiptStore.showReceiptDialog()">
                  <v-icon start icon="mdi-currency-usd"></v-icon>Payment
                </v-btn>
              </v-col>
            </v-row>
          </v-container> -->
        </v-sheet>
      </v-col>

      <!-- change layout v-->
    </v-row>
  </v-container>
</template>
